module List where

-- Verstecken vordefinierter Bezeichner:
import Prelude hiding ((++))

-- "Unsere" Listen
data List alpha = Empty 
            | Cons alpha (List alpha)
            deriving (Eq, Show)

-- Verkettung zweier Listen
(++) :: List alpha-> List alpha-> List alpha
Empty ++ t      = t
(Cons c s) ++ t = Cons c (s++ t)

-- Example expressions:
ex2 =
 Cons 3 Empty ++ Cons 5 (Cons 57 Empty)

ex1 = 
 Cons 'p' (Cons 'i' Empty) ++ Cons '3' Empty

